import java.applet.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class SpecifyBc extends Frame {
	MenuBar menubar;
	Menu read, save, action;
	MenuItem Rmesh, Rbel, Rcoef, RtrueBC, RtrueVC;
	MenuItem Smesh, Sbel, Scoef;
	Button boutonS, boutonL, boutonF1, boutonF2, boutonQ, 
	boutonZ, boutonDZ, boutonRD, boutonL1, boutonP1, boutonL2,
	boutonL3,boutonL4, boutonS2, boutonS3, boutonF3, boutonF4,
	boutonF5,boutonF6;
	FileDialog file_dialog;
	String filename;
	String dirname;
	String flagname;
	int bdyflag;
	Courbe co;
	int npoint;
	BarreEtat etat;
	zGra graphique;
	Vector recup;
	int x1,y1,x2,y2,x3,y3,i0,j0,drag;
	double facx,facy,xx,yy,x0,y0;
	TextField textfield;
	int width=500, height=600;
	private int nzoom, lire=0, lireGrad=0, spline=0;

	public SpecifyBc(String name) {
	        dirname = new String(name);
		Panel tools;
	        setTitle("Boundary Tagger");
		setSize(width, height);
		setBackground(Color.lightGray);
		setBackground(Color.lightGray);

// definition of the menu bar

		menubar = new MenuBar();
		this.setMenuBar(menubar);
		read = new Menu("Read");
		save = new Menu("Save");
		action = new Menu("Action");
		Rmesh = new MenuItem("Read Mesh");
		Rbel = new MenuItem("Read Bel");
		Rcoef = new MenuItem("Read Coef");
		RtrueBC = new MenuItem("Read TrueBC");
		RtrueVC = new MenuItem("Read True V");
		Smesh = new MenuItem("Save Mesh");
		Sbel = new MenuItem("Save Bel");
		Scoef = new MenuItem("Save Coef");
		read.add(Rmesh);
		read.add(Rbel);
		read.add(Rcoef);
		read.add(RtrueBC);
		read.add(RtrueVC);
		save.add(Smesh);
		save.add(Sbel);
		save.add(Scoef);
		menubar.add(read);
		menubar.add(save);
		
		tools = new Panel();
		tools.setLayout(new GridLayout(3,7));
	        boutonF1 = new Button("UnSelect");
 	        boutonF2 = new Button("Select");
 	        boutonF3 = new Button("Calc Coef");
 	        boutonF4 = new Button("Spline");
 	        boutonF5 = new Button("Corner");
 	        boutonF6 = new Button("Smoother");
	        boutonZ = new Button("Zoom");
 	        boutonDZ = new Button("unZoom");
 	        boutonRD = new Button("reDraw");
 	        boutonP1 = new Button("Projection");
	        boutonQ = new Button("Quitter");
		textfield = new TextField("1", 5);
		tools.add(boutonF1);
		tools.add(boutonF2);
		tools.add(boutonF3);
		tools.add(boutonF4);
		tools.add(boutonF5);
		tools.add(boutonF6);
		tools.add(boutonZ);
		tools.add(boutonDZ);
		tools.add(boutonRD);
		tools.add(boutonP1);
		tools.add(boutonQ);
		tools.add(new Label("Bdy Flag"));
		tools.add(textfield);
		etat = new BarreEtat();
		this.setLayout(new BorderLayout(3,1));
		this.add(tools,"North");
		co = new Courbe();
		this.add(graphique = new zGra(etat, co),"Center");
		this.add(etat,"South");
	}
	public boolean action(Event e, Object What){

/*-------------------------------- Exit ---------------------------*/

		if (e.target == boutonQ){
			this.hide();
			this.dispose();
			System.exit(0);
			return true;
		}

/*------------------------ Read actions ---------------------------*/

		else if (e.target == Rmesh){
			file_dialog = new FileDialog(this, "Open File", 
			FileDialog.LOAD);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			System.out.println("read: "+filename);
			co.ReadMesh(filename);
			co.maille();
			co.fact();
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "File read" );
			graphique.puttoback();
			lire=1;
			return true;
		}
		else if (e.target == Rbel){
		  if (lire==1) {
			file_dialog = new FileDialog(this, "Open File", 
			FileDialog.LOAD);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			System.out.println("read: "+filename);
			co.ReadBel(filename);
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "File read" );
			graphique.puttoback();
			return true;
		   }
		   else  etat.afficheMessage( "read mesh first" );

		}
		else if (e.target == Rcoef){
		  if (lire==1) {
			file_dialog = new FileDialog(this, "Open File", 
			FileDialog.LOAD);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			System.out.println("read: "+filename);
			co.ReadCoef(filename);
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "File read" );
			graphique.puttoback();
			return true;
		   }
		   else  etat.afficheMessage( "read mesh first" );

		}
		else if (e.target == RtrueBC){
		  if (lire==1) {
			file_dialog = new FileDialog(this, "Open File", 
			FileDialog.LOAD);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			System.out.println("read: "+filename);
			co.ReadTrueBD(filename);
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "File read" );
			graphique.puttoback();
			return true;
		   }
		   else  etat.afficheMessage( "read mesh first" );

		}
		else if (e.target == RtrueVC){
		  if (lire==1) {
			file_dialog = new FileDialog(this, "Open File", 
			FileDialog.LOAD);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			System.out.println("read: "+filename);
			co.ReadTrueBDV(filename);
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "File read" );
			graphique.puttoback();
			lireGrad=1;
			return true;
		   }
		   else  etat.afficheMessage( "read mesh first" );

		}

/*------------------------ Actions ---------------------------*/

		else if (e.target == boutonP1){
			co.ProjStr();
			co.fact();
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "Projection done" );
			graphique.puttoback();
			lire=1;
			return true;
		}
		else if (e.target == boutonZ){
		        drag=graphique.dragged();
			if (drag==1) {
			recup = new Vector(graphique.newZoom());
			recup2();
			Dimension d=graphique.size();
			recup= new Vector(co.zoom(x1, y1, x2, y2, d.width,
			d.height, 1));
			recupere();
			graphique.puttoback();
           		etat.afficheMessage( "Zoom done" );
			}
			else etat.afficheMessage( "Rect too small" );
			return true;
		}
		else if (e.target == boutonDZ){
			Dimension d=graphique.size();
			recup= new Vector(co.zoom(0, 0, 1, 1, d.width, d.height,
			-1));
			recupere();
			graphique.puttoback();
           		etat.afficheMessage( "unZoom done" );
			return true;
		}
		else if (e.target == boutonRD){
			Dimension d=graphique.size();
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
			graphique.puttoback();
           		etat.afficheMessage( "reDraw done" );
			return true;
		}

		else if (e.target == boutonF1){
			recup = new Vector(graphique.newZoom());
			recup2();
			co.UnSelection();
			graphique.puttoback();
           		etat.afficheMessage( "Select done" );
			return true;
		}
		else if (e.target == boutonF2){
		        drag=graphique.dragged();
			flagname= new String(textfield.getText());
			bdyflag= Integer.parseInt(flagname);
			if (drag==1) {
			recup = new Vector(graphique.newZoom());
			recup2();
		        co.findClicked2(x1, y1, x2, y2);
			}
			co.selection(bdyflag);
			graphique.puttoback();
           		etat.afficheMessage( "Select done" );
			return true;
		}
		else if (e.target == boutonF3){
		  if (lireGrad==1 || spline==1) {
		        co.ComputeCoef();
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "Bdy Coefficient done" );
			graphique.puttoback();
			return true;
		  }
		}
		else if (e.target == boutonF4){
		  if (lire==1) {
		        co.CubicSplineInit();
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "Spline calculation done" );
			graphique.puttoback();
			spline=1;
			return true;
		  }
		}
		else if (e.target == boutonF5){
		  if (lire==1) {
		        co.SmoothCorner();
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "Corners smoothed" );
			graphique.puttoback();
			return true;
		  }
		}
		else if (e.target == boutonF6){
		  if (lire==1) {
		        co.SmoothMesh();
			Dimension d=graphique.size();
			nzoom=1;
			recup= new Vector(co.zoom(0, 0, 0, 0, d.width, d.height,
			0));
			recupere();
            		etat.afficheMessage( "Mesh smoothed" );
			graphique.puttoback();
			return true;
		  }
		}

/*------------------------ Save actions ---------------------------*/

		else if (e.target == Smesh){
			file_dialog = new FileDialog(this, "Save As", 
			FileDialog.SAVE);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			co.SaveMesh(filename);
			System.out.println("save: "+filename);
			return true;
		}
		else if (e.target == Sbel){
			file_dialog = new FileDialog(this, "Save As", 
			FileDialog.SAVE);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			co.SaveBel(filename);
			System.out.println("save: "+filename);
			return true;
		}
		else if (e.target == Scoef){
			file_dialog = new FileDialog(this, "Save As", 
			FileDialog.SAVE);
			file_dialog.setDirectory(dirname);
			file_dialog.show();
			if ( file_dialog.getFile() == null ) return true;
			filename = new String(file_dialog.getDirectory()+
			file_dialog.getFile());
			co.SaveCoef(filename);
			System.out.println("save: "+filename);
			return true;
		}
		return false;
	}

	public static void main(String args[]) {
		Frame f = new SpecifyBc(args[0]);
//		f.pack();
		f.show();
	}

	public void recupere() {
		String ci;

		ci = recup.get(0).toString();
		i0 = Integer.parseInt(ci);
		ci = recup.get(1).toString();
		j0 = Integer.parseInt(ci);
		ci = recup.get(2).toString();
		facx = Double.parseDouble(ci);
		ci = recup.get(3).toString();
		facy = Double.parseDouble(ci);
 		ci = recup.get(4).toString();
		x0 = Double.parseDouble(ci);
 		ci = recup.get(5).toString();
		y0 = Double.parseDouble(ci);
	}
	public void recup2() {
		x1 = Integer.parseInt(recup.get(0).toString());
		y1 = Integer.parseInt(recup.get(1).toString());
		x2 = Integer.parseInt(recup.get(2).toString());
		y2 = Integer.parseInt(recup.get(3).toString());
	}


}
