import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;

public class zGra extends Canvas 
			implements MouseMotionListener {
	private BarreEtat etat;
	private Courbe courbe;
	private int x1,y1,x2,y2,x3,y3,i0,j0;
	private double facx,facy,xx,yy,x0,y0;
	int click=0, drag=0;
	private Image offscreen;
	private int imagewidth, imageheight;

	public zGra(BarreEtat etat, Courbe co) {
		addMouseMotionListener(this);
		this.etat = etat;
		courbe = co;
//		this.courbe = co;
		setBackground(Color.black);
		setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
	}
	public Vector newZoom() {
		Vector result = new Vector();
		Integer ii = new Integer(x1);
		Integer jj = new Integer(y1);
		result.add(ii);
		result.add(jj);
		Integer iii = new Integer(x2);
		Integer jjj = new Integer(y2);
		result.add(iii);
		result.add(jjj);
		return result;
	}
	public int dragged() {
		return drag;
	}
	public void paint ( Graphics g) {
		int x, y, width, height;
		courbe.dessine(g);
	}
	public void puttoback () {
		Dimension d=this.size();
		int x, y;

		 offscreen = this.createImage(d.width, d.height);
		 imagewidth = d.width;
		 imageheight = d.height;
		 Graphics g = offscreen.getGraphics();
		 g.clipRect(0, 0, imagewidth, imageheight);
		 g.setColor(Color.black);
		 g.fillRect(0,0,imagewidth,imageheight);
		 paint(g);
		 g=this.getGraphics();
		 g.drawImage(offscreen, 0, 0, this);
		    courbe.SelectClicked();
		    courbe.drawClicked(g);
	}
	public void mouseMoved(MouseEvent e) {
		etat.afficheCoord(e.getX(), e.getY());
	}
	public boolean mouseDown(Event e, int x, int y) {
		drag=0;
		etat.afficheCoord(x,y);
		x1=x; y1=y;
		return true;
	}
	public boolean mouseUp(Event e, int x, int y) {
		Graphics g=this.getGraphics();
		Dimension d=this.size();
		int close=10;

		etat.afficheCoord(x,y);

		x2 = x; y2 = y;
                x3=Math.abs(x1-x2);
                y3=Math.abs(y1-y2);
		if ( x3 < close && y3 < close) {
		    drag=0;
		    courbe.findClicked1(x,y);
		    courbe.SelectClicked();
		    g.clipRect(0, 0, d.width, d.height);
		    g.drawImage(offscreen, 0, 0, this);
		    courbe.drawClicked(g);
		}
		else drag=1;
		return true;
	}
	public void mouseDragged(MouseEvent e) {
		int x, y, width, height;
		Graphics g=this.getGraphics();
		Dimension d=this.size();
			x2 = e.getX();
			y2 = e.getY();
			x = Math.min( x1, x2 );
			y = Math.min( y1, y2 );
			width  = Math.abs( x1 - x2 );
			height = Math.abs( y1 - y2 );
			etat.afficheCoord(x2, y2);
			click=0;
//			g.clipRect(x1, y1, width+1, height+1);
			g.clipRect(0, 0, d.width, d.height);
			g.drawImage(offscreen, 0, 0, this);
			g.setColor(Color.red);
			g.drawRect(x,y,width,height);
		courbe.drawClicked(g);
	}
}
